diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/iw/partition_ui_helpers_gui.py anaconda-storage/iw/partition_ui_helpers_gui.py
--- anaconda/iw/partition_ui_helpers_gui.py	2009-02-13 23:03:10.000000000 -0600
+++ anaconda-storage/iw/partition_ui_helpers_gui.py	2009-02-17 13:22:26.000000000 -0600
@@ -28,10 +28,9 @@
 import iutil
 
 from constants import *
-from fsset import *
 from partIntfHelpers import *
-from partRequests import *
 from partedUtils import *
+from storage.formats import device_formats, getFormat
 
 import gettext
 _ = lambda x: gettext.ldgettext("anaconda", x)
@@ -72,13 +71,24 @@
 
     return label
 
+defaultMountPoints = ['/', '/boot', '/home', '/tmp', '/usr',
+                      '/var', '/usr/local', '/opt']
+
+if iutil.isS390():
+    # Many s390 have 2G DASDs, we recomment putting /usr/share on its own DASD
+    defaultMountPoints.insert(5, '/usr/share')
+
+if iutil.isEfi():
+    defaultMountPoints.insert(2, '/boot/efi')
+
 def createMountPointCombo(request, excludeMountPoints=[]):
     mountCombo = gtk.combo_box_entry_new_text()
 
     mntptlist = []
 
-    if request.type != REQUEST_NEW and request.fslabel:
-	mntptlist.append(request.fslabel)
+    label = getattr(request.format, "label", None)
+    if request.exists and isinstance(label, str) and label.startswith("/"):
+	mntptlist.append(label)
         idx = 0
     
     for p in defaultMountPoints:
@@ -90,9 +100,8 @@
 
     map(mountCombo.append_text, mntptlist)
 
-    mountpoint = request.mountpoint
-
-    if request.fstype and request.fstype.isMountable():
+    if request.format.type != "none" and request.format.mountable:
+        mountpoint = request.format.mountpoint
         mountCombo.set_sensitive(1)
         if mountpoint:
             mountCombo.get_children()[0].set_text(mountpoint)
@@ -107,13 +116,14 @@
     return mountCombo
 
 def setMntPtComboStateFromType(fstype, mountCombo):
+    format = getFormat(fstype)
     prevmountable = mountCombo.get_data("prevmountable")
     mountpoint = mountCombo.get_data("saved_mntpt")
 
-    if prevmountable and fstype.isMountable():
+    if prevmountable and format.mountable:
         return
 
-    if fstype.isMountable():
+    if format.mountable:
         mountCombo.set_sensitive(1)
         if mountpoint != None:
             mountCombo.get_children()[0].set_text(mountpoint)
@@ -125,7 +135,7 @@
         mountCombo.get_children()[0].set_text(_("<Not Applicable>"))
         mountCombo.set_sensitive(0)
 
-    mountCombo.set_data("prevmountable", fstype.isMountable())
+    mountCombo.set_data("prevmountable", format.mountable)
 
 def fstypechangeCB(widget, mountCombo):
     fstype = widget.get_active_value()
@@ -134,24 +144,25 @@
 def createAllowedDrivesStore(disks, reqdrives, drivelist, selectDrives=True,
                              disallowDrives=[]):
     drivelist.clear()
-    drives = disks.keys()
-    drives.sort()
-    for drive in drives:
-        size = disks[drive].device.getSize(unit="MB")
+    for disk in disks:
         selected = 0
 
         if selectDrives:
             if reqdrives:
-                if drive in reqdrives:
+                if disk.name in reqdrives:
                     selected = 1
             else:
-                if drive not in disallowDrives:
+                if disk.name not in disallowDrives:
                     selected = 1
 
-        sizestr = "%8.0f MB" % size
-        drivelist.append_row((drive, sizestr, disks[drive].device.model), selected)
+        sizestr = "%8.0f MB" % disk.size
+        # TODO: abstract disk model so we don't have to reach into parted.Disk
+        drivelist.append_row((disk.name,
+                              sizestr,
+                              disk.partedDisk.device.model),
+                             selected)
 
-    if len(disks.keys()) < 2:
+    if len(disks) < 2:
         drivelist.set_sensitive(False)
     else:
         drivelist.set_sensitive(True)
@@ -175,31 +186,33 @@
     store = gtk.TreeStore(gobject.TYPE_STRING, gobject.TYPE_PYOBJECT)
     fstypecombo = datacombo.DataComboBox(store)
     
-    types = fileSystemTypeGetTypes()
+    types = device_formats.keys()
     if availablefstypes:
         names = availablefstypes
     else:
         names = types.keys()
-    if fstype and fstype.isSupported() and fstype.isFormattable():
+    fs = getFormat(fstype)
+    if fs and fs.supported and fs.formattable:
         default = fstype
     else:
-        default = fileSystemTypeGetDefault()
+        default = get_default_filesystem_type()
         
     names.sort()
     defindex = 0
     i = 0
     for name in names:
-        if not fileSystemTypeGet(name).isSupported():
+        format = getFormat(name)
+        if not format.supported:
             continue
 
         if ignorefs and name in ignorefs:
             continue
         
-        if fileSystemTypeGet(name).isFormattable():
-            fstypecombo.append(name, types[name])
-            if default and default.getName() == name:
+        if format.formattable:
+            fstypecombo.append(name, device_formats[name])
+            if default and default.type == name:
                 defindex = i
-                defismountable = types[name].isMountable()
+                defismountable = format.mountable
             i = i + 1
 
     fstypecombo.set_active(defindex)
@@ -209,7 +222,7 @@
 
     if mountCombo:
         mountCombo.set_data("prevmountable",
-                            fstypecombo.get_active_value().isMountable())
+                            fstypecombo.get_active_value()().mountable)
         mountCombo.connect("changed", mountptchangeCB, fstypecombo)
 
     return fstypecombo
@@ -218,7 +231,7 @@
     if iutil.isEfi() and widget.get_children()[0].get_text() == "/boot/efi":
         fstypecombo.set_active_text("efi")
     if widget.get_children()[0].get_text() == "/boot":
-        fstypecombo.set_active_text(fileSystemTypeGetDefaultBoot().getName())
+        fstypecombo.set_active_text(get_default_filesystem_type(boot=True))
 
 def resizeOptionCB(widget, resizesb):
     resizesb.set_sensitive(widget.get_active())
@@ -282,11 +295,11 @@
 def createPreExistFSOptionSection(origrequest, maintable, row, mountCombo,
                                   partitions, ignorefs=[]):
     rc = {}
-    ofstype = origrequest.fstype
+    ofstype = origrequest.format.type
 
     formatcb = gtk.CheckButton(label=_("_Format as:"))
     maintable.attach(formatcb, 0, 1, row, row + 1)
-    formatcb.set_active(istruefalse(origrequest.format))
+    formatcb.set_active(istruefalse(origrequest.format.exists))
     rc["formatcb"] = formatcb
 
     fstypeCombo = createFSTypeMenu(ofstype, fstypechangeCB,
@@ -296,8 +309,9 @@
     row += 1
     rc["fstypeCombo"] = fstypeCombo
 
-    if not formatcb.get_active() and not origrequest.migrate:
-	mountCombo.set_data("prevmountable", ofstype.isMountable())
+    # TODO: sort out fs migration
+    if not formatcb.get_active() and not origrequest.format.migrate:
+	mountCombo.set_data("prevmountable", getFormat(ofstype).mountable)
 
     # this gets added to the table a bit later on
     lukscb = gtk.CheckButton(_("_Encrypt"))
@@ -306,11 +320,12 @@
                     (fstypeCombo, mountCombo, ofstype, lukscb))
 
 
-    if origrequest.origfstype.isMigratable():
+    if origrequest.format.migratable:
 	migratecb = gtk.CheckButton(label=_("Mi_grate filesystem to:"))
-        migratecb.set_active(istruefalse(origrequest.migrate))
+        migratecb.set_active(istruefalse(origrequest.format.migrate))
 
-	migtypes = origrequest.origfstype.getMigratableFSTargets()
+        # TODO: unimplemented
+	migtypes = origrequest.format.migrationTargets
 
 	maintable.attach(migratecb, 0, 1, row, row + 1)
 	migfstypeCombo = createFSTypeMenu(ofstype, None, None,
@@ -326,7 +341,7 @@
 	migratecb = None
 	migfstypeCombo = None
 
-    if origrequest.isResizable(partitions):
+    if origrequest.resizable:
         resizecb = gtk.CheckButton(label=_("_Resize"))
         resizecb.set_active(origrequest.targetSize is not None)
         rc["resizecb"] = resizecb
@@ -357,7 +372,7 @@
 
         formatcb.connect("toggled", formatOptionResizeCB, resizesb)
 
-    if origrequest.encryption:
+    if origrequest.format.type == "luks":
         lukscb.set_active(1)
         lukscb.set_data("encrypted", 1)
     else:
diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/kickstart.py anaconda-storage/kickstart.py
--- anaconda/kickstart.py	2009-02-13 23:03:10.000000000 -0600
+++ anaconda-storage/kickstart.py	2009-02-17 13:25:23.000000000 -0600
@@ -24,13 +24,11 @@
 import os
 import tempfile
 from autopart import *
-from fsset import *
 from flags import flags
 from constants import *
 import sys
 import raid
 import string
-import partRequests
 import urlgrabber.grabber as grabber
 import lvm
 import warnings
@@ -149,8 +147,8 @@
         self.handler.id.instClass.setDefaultPartitioning(self.handler.id, doClear = 0)
 
         if self.encrypted:
-            self.handler.id.partitions.autoEncrypt = True
-            self.handler.id.partitions.encryptionPassphrase = self.passphrase
+            self.handler.id.storage.autoEncrypt = True
+            self.handler.id.storage.encryptionPassphrase = self.passphrase
 
         self.handler.skipSteps.extend(["partition", "zfcpconfig", "parttype"])
         return retval
@@ -181,7 +179,7 @@
             self.handler.id.bootloader.doUpgradeOnly = 1
 
         if self.driveorder:
-            hds = isys.hardDriveDict().keys()
+            hds = [d.name for d in self.handler.id.storage.disks]
             for disk in self.driveorder:
                 if disk not in hds:
                     raise KickstartValueError, formatErrorMsg(self.lineno, msg="Specified nonexistent disk %s in driveorder command" % disk)
@@ -269,15 +267,13 @@
     def parse(self, args):
         retval = commands.ignoredisk.F8_IgnoreDisk.parse(self, args)
 
-        diskset = self.handler.id.diskset
         for drive in self.ignoredisk:
-            if not drive in diskset.skippedDisks:
-                diskset.skippedDisks.append(drive)
+            if not drive in self.handler.id.storage.ignoredDisks:
+                self.handler.id.storage.ignoredDisks.append(drive)
 
-        diskset = self.handler.id.diskset
         for drive in self.onlyuse:
-            if not drive in diskset.exclusiveDisks:
-                diskset.exclusiveDisks.append(drive)
+            if not drive in self.handler.id.storage.exclusiveDisks:
+                self.handler.id.storage.exclusiveDisks.append(drive)
 
         return retval
 
@@ -304,8 +300,6 @@
             if self.handler.id.iscsi.addTarget(**kwargs):
                 log.info("added iscsi target: %s" %(target.ipaddr,))
 
-        # FIXME: flush the drive dict so we figure drives out again
-        isys.flushDriveDict()
         return retval
 
 class IscsiName(commands.iscsiname.FC6_IscsiName):
diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/livecd.py anaconda-storage/livecd.py
--- anaconda/livecd.py	2009-02-11 21:36:30.000000000 -0600
+++ anaconda-storage/livecd.py	2009-02-15 15:38:05.000000000 -0600
@@ -41,7 +41,6 @@
 import backend
 import isys
 import iutil
-import fsset
 
 import packages
 
@@ -174,16 +173,9 @@
         osimg = self._getLiveBlockDevice() # the real image
         osfd = os.open(osimg, os.O_RDONLY)
 
-        r = anaconda.id.fsset.getEntryByMountPoint("/")
-        rootfs = r.device.setupDevice()
-        rootfd = os.open(rootfs, os.O_WRONLY)
-
-        # set the rootfs to have the right type.  this lets things work
-        # given ext2 or ext3 (and in the future, ext4)
-        # FIXME: should we try to migrate if there isn't a match?
-        roottype = isys.readFSType(osimg)
-        if roottype is not None:
-            r.fsystem = fsset.fileSystemTypeGet(roottype)
+        rootDevice = anaconda.id.fsset.rootDevice
+        rootDevice.setup()
+        rootfd = os.open(rootDevice.path, os.O_WRONLY)
 
         readamt = 1024 * 1024 * 8 # 8 megs at a time
         size = self._getLiveSize()
@@ -222,6 +214,7 @@
         anaconda.id.instProgress = None
 
     def _doFilesystemMangling(self, anaconda):
+        # FIXME: this whole method is a big fucking mess
         log.info("doing post-install fs mangling")
         wait = anaconda.intf.waitWindow(_("Doing post-installation"),
                                         _("Performing post-installation filesystem changes.  This may take several minutes..."))
@@ -233,12 +226,16 @@
         anaconda.id.fsset.mountFilesystems(anaconda)
 
         # restore the label of / to what we think it is
-        r = anaconda.id.fsset.getEntryByMountPoint("/")
-        anaconda.id.fsset.labelEntry(r, anaconda.rootPath, True)
+        rootDevice = anaconda.id.fsset.rootDevice
+        rootDevice.setup()
         # ensure we have a random UUID on the rootfs
         # FIXME: this should be abstracted per filesystem type
-        iutil.execWithRedirect("tune2fs", ["-U", "random", "/dev/%s" % (r.device.getDevice())],
-                               stdout="/dev/tty5", stderr="/dev/tty5",
+        iutil.execWithRedirect("tune2fs",
+                               ["-U",
+                                "random",
+                                rootDevice.path],
+                               stdout="/dev/tty5",
+                               stderr="/dev/tty5",
                                searchPath = 1)
 
         # for any filesystem that's _not_ on the root, we need to handle
@@ -246,6 +243,7 @@
         # this is pretty distasteful, but should work with things like
         # having a separate /usr/local
 
+        # XXX wow, what in the hell is going on here?
         # get a list of fsset entries that are relevant
         entries = sorted(filter(lambda e: not e.fsystem.isKernelFS() and \
                                 e.getMountPoint(), anaconda.id.fsset.entries))
@@ -314,13 +312,12 @@
 
     def _resizeRootfs(self, anaconda, win = None):
         log.info("going to do resize")
-        r = anaconda.id.fsset.getEntryByMountPoint("/")        
-        rootdev = r.device.getDevice()
+        rootDevice = anaconda.id.fsset.rootDevice
 
         # FIXME: we'd like to have progress here to give an idea of
         # how long it will take.  or at least, to give an indefinite
         # progress window.  but, not for this time
-        cmd = ["resize2fs", "/dev/%s" %(rootdev,), "-p"]
+        cmd = ["resize2fs", rootDevice.path, "-p"]
         out = open("/dev/tty5", "w")
         proc = subprocess.Popen(cmd, stdout=out, stderr=out)
         rc = proc.poll()
@@ -376,9 +373,8 @@
         # FIXME: really, this should be in the general sanity checking, but
         # trying to weave that in is a little tricky at present.
         ossize = self._getLiveSizeMB()
-        slash = anaconda.id.partitions.getRequestByMountPoint("/")
-        if slash and \
-           slash.getActualSize(anaconda.id.partitions, anaconda.id.diskset) < ossize:
+        slash = anaconda.id.fsset.rootDevice
+        if slash.size < ossize:
             rc = anaconda.intf.messageWindow(_("Error"),
                                         _("The root filesystem you created is "
                                           "not large enough for this live "
@@ -391,7 +387,6 @@
                 return DISPATCH_BACK
             else:
                 sys.exit(1)
-        
 
     # package/group selection doesn't apply for this backend
     def groupExists(self, group):
diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/network.py anaconda-storage/network.py
--- anaconda/network.py	2009-02-11 21:36:30.000000000 -0600
+++ anaconda-storage/network.py	2009-02-17 13:26:12.000000000 -0600
@@ -585,8 +585,8 @@
             # tell NM not to touch the interface(s) actually used for /, but we
             # have no logic to determine that
             if anaconda is not None:
-                rootdev = anaconda.id.fsset.getEntryByMountPoint("/").device
-                if rootdev.isNetdev():
+                rootdev = anaconda.id.storage.fsset.rootDevice
+                if rootdev.isNetdev:
                     f.write("NM_CONTROLLED=no\n")
 
             f.close()
diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/packages.py anaconda-storage/packages.py
--- anaconda/packages.py	2009-02-13 23:03:10.000000000 -0600
+++ anaconda-storage/packages.py	2009-02-17 12:52:20.000000000 -0600
@@ -174,12 +174,14 @@
                                         type="custom", custom_icon="error", custom_buttons=[_("_Reboot")])
 	            sys.exit(0)
 
-            anaconda.id.fsset.formatSwap(anaconda.rootPath)
-            anaconda.id.fsset.turnOnSwap(anaconda.rootPath)
-            anaconda.id.fsset.makeFilesystems(anaconda.rootPath,
-                                              anaconda.backend.skipFormatRoot)
-            anaconda.id.fsset.mountFilesystems(anaconda,0,0,
-                                               anaconda.backend.skipFormatRoot)
+            anaconda.id.storage.processActions(anaconda.intf)
+            anaconda.id.fsset.turnOnSwap(anaconda.intf)
+            #anaconda.id.fsset.makeFilesystems(anaconda.rootPath,
+            #                                  anaconda.backend.skipFormatRoot)
+            anaconda.id.storage.fsset.mountFilesystems(anaconda,
+                                                       raiseErrors=False,
+                                                       readOnly=False,
+                                                       anaconda.backend.skipFormatRoot)
 
 def setupTimezone(anaconda):
     # we don't need this on an upgrade or going backwards
